"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const defaultPoolSize = navigator.hardwareConcurrency || 4;
const isAbsoluteURL = (value) => /^(https?:)?\/\//i.test(value);
function selectWorkerImplementation() {
    return class BrowserWorker extends Worker {
        constructor(url, options) {
            if (typeof url === "string" && isAbsoluteURL(url)) {
                // Create source code blob loading JS file via `importScripts()`
                // to circumvent worker CORS restrictions
                const blob = new Blob([`importScripts(${JSON.stringify(url)});`], { type: "application/javascript" });
                url = URL.createObjectURL(blob);
            }
            super(url, options);
        }
    };
}
exports.default = {
    defaultPoolSize,
    selectWorkerImplementation
};
